/*
       VScrollbar.h 1.1 for X11R6 & GNU C Compiler

       Copyright (C) 1996, 1997, 1998 Syllabub
       Maroontress Fast Software.
*/

#define VSCBARSEP 2     /* window$B$H=D(Bscroll bar$B$N6-3&$N(Bpixel$B?t(B */
#define VSCBARWIDTH 16  /* $B=D(Bscroll bar$B$N2#I}$N(Bpixel$B?t(B */
#define VSCBARHMIN 12    /* $B=D(Bscroll bar$B$N9b$5$N:G>.(Bpixel$B?t(B (2$B0J>e(B) */

typedef struct {
    Display * disp;
    Window parent;
    Window window;
    Window catch;
    Window bar;
    GC gc;
    Cursor cursor;
    unsigned long pixels[6];
    int current;        /* ($BI=<(HO0O$N@hF,9T(B) - 1 */
    int maxline;        /* $BAm9T?t(B */
    int height;         /* $BI=<(HO0O$N(Bpixel$B?t(B, $B2DJQ(B */
    int lines;          /* $BI=<(HO0O$N9T?t(B, $B2DJQ(B */         
    int parline;        /* 1$B9T$"$?$j$N(Bpixel$B?t(B, $B8GDj(B */
    int grabbed;        /* $B%9%/%m!<%k%P!<$,%I%i%C%0$5$l$F$$$l$P(BTrue */
    int orgx, orgy;     /* drag$B3+;O;~$N%k!<%H%&%#%s%I%&$KBP$9$k%]%$%s%H(B */
    int orgc;           /* (drag$B3+;O;~$NI=<(HO0O$N@hF,9T(B) - 1 */
    int orgp;           /* drag$B3+;O;~$N(Bcatch$B$N(Bbar$B$KBP$9$k(By$B:BI8(B */
    int button;         /* drag$B3+;O;~$K2!$5$l$F$$$?%\%?%s(B */
    void (*scroll)(int, int);
    void (*adjust)(int);
} SylVScrollbar;

/*
    Function:
        ReserveSylVScrollbar - $B=DJ}8~$N%9%/%m!<%k%P!<$r3NJ]$9$k!#(B

    Synopsis:
        SylVScrollbar * ReserveSylVScrollbar(display, window, component
	    beginning, total_lines, unit_height, scroll, adjust);
	Display *display;
        Window window;
	char *component;
	int beginning;
	int lines;
	int unit;
	void (*scroll)(int, int);
	void (*adjust)(int);
	
    Description:
        ReserveSylVScrollbar$B$O9TC10L$N%9%/%m!<%k=hM}$r=u$1$k!#M-8B$J@~2h(B
	$B:Q$_$N(BPixmap$B$rItJ,I=<($5$;$k$3$H$K$OIT8~$-$G$"$k!#$=$N>l9g$OB>$N(B
	$B5!9=$rMxMQ$7$?J}$,M-Mx$K$J$k!#(B

        display$B$O(BDisplay$B<1JL;R!#(Bwindow$B$O%9%/%m!<%k$NBP>]$H$J$k(BWindow$B<1JL(B
	$B;R!#(Bbeginning$B$OI=<(HO0O$N@hF,9T!#$?$@$7Bh(Bn$B9TL\$rI=<(HO0O$N@hF,9T$K(B
	$BI=<($9$k$?$a$K$O!"(Bbegin$B$K(Bn - 1$B$rBeF~$9$k!#(Btotal_lines$B$OAm9T?t!#(B
	unit_height$B$O(B1$B9T$"$?$j$N%T%/%;%k?t!#(B

	scroll$B$O%3!<%k%P%C%/4X?t$X$N%]%$%s%?!#(Bscroll(n)$B$G(Bn$B9T%9%/%m!<%k$9(B
	$B$k$h$&$K@_7W$7$F$"$kI,MW$,$"$k!#(Badjust$B$b%3!<%k%P%C%/4X?t$X$N%]%$(B
	$B%s%?!#(Badjust(n - 1)$B$G(Bn$B9TL\$,I=<(HO0O$N@hF,9T$KI=<($5$l$k$h$&$K@_(B
	$B7W$7$F$"$kI,MW$,$"$k!#(Bscroll$B$H(Badjust$B$O8F=PB&$+$iD>@\8F$s$G$O$J$i(B
	$B$J$$!#$=$l$>$l(BScroll$B!A(B, Jump$B!A$r8F$V$3$H!#$?$@$7!"(Bscroll$B$NFbIt$+(B
	$B$i(Badjust$B$r8F$V!"$^$?$O$=$N5U$r$9$k$3$H$O2DG=!#(B

	ReserveSylVScrollbar$B$O<:GT$9$k$H(BNULL$B$rJV$9!#(B

    See also:
        SendSylVScrollbar, PutbackSylVScrollbar, ScrollSylVScrollbar,
	JumpSylVScrollbar, RewriteSylVScrollbar, RangeSylVScrollbar
*/

SylVScrollbar * ReserveSylVScrollbar(Display *, Window, char *, int, int, int,
				     void (*)(int, int), void (*)(int));
int SendSylVScrollbar(SylVScrollbar *, XEvent *);
void ScrollSylVScrollbar(SylVScrollbar *, int);
void JumpSylVScrollbar(SylVScrollbar *, int);
#define RewriteSylVScrollbar(x) JumpSylVScrollbar((x), (x)->current)
void RangeSylVScrollbar(SylVScrollbar *, int);
void PutbackSylVScrollbar(SylVScrollbar *);
